
/*
Version  November 26, 2007

          
PriceSeries.mqh 
  (): MetaTrader\experts\include\
Heiken Ashi#.mq4
  (): MetaTrader\indicators\
*/
//+==================================================================+
//|                                                      MAMA_NK.mq4 |
//|                    MQL4 CODE: Copyright  2007, Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+==================================================================+
#property link  "farria@mail.redcom.ru/"
//----     
#property indicator_chart_window 
//----   
#property indicator_buffers 2 
//----  
#property indicator_color1 Blue
#property indicator_color2 Red
//----   
#property indicator_width1 1
#property indicator_width2 1
//----    
extern double FastLimit = 0.5;
extern double SlowLimit = 0.05;
extern int IPC = 4;/*  ,      
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 
8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW, 11-Heiken Ashi Low, 12-Heiken Ashi High,  
13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
//----  
double FAMA[];
double MAMA[];
//+==================================================================+
//----+   PriceSeries
//----+   PriceSeriesAlert 
#include <PriceSeries.mqh>
//+==================================================================+
//| #MAMA initialization function                                    |
//+==================================================================+
int init()
  {
//----   
    SetIndexStyle(0, DRAW_LINE);
    SetIndexStyle(1, DRAW_LINE);
//---- 2     
    SetIndexBuffer(0, FAMA);
    SetIndexBuffer(1, MAMA);
//----   ,      
    SetIndexEmptyValue(0,0.0);
    SetIndexEmptyValue(1,0.0);
//----        
    IndicatorShortName("#MAMA");
    SetIndexLabel(0, "#FAMA");
    SetIndexLabel(1, "#MAMA");
//----   ,       
    SetIndexDrawBegin(0, 50);
    SetIndexDrawBegin(1, 50);
//----       
    PriceSeriesAlert(IPC);
//----  
    return(0);
  }
//+==================================================================+
//|    #MAMA                                                         |
//+==================================================================+
int start()
  {
    int BARS=Bars;    
    //----       
    if(BARS <= 7) return(0);
    //----     
    static double smooth[1], detrender[1], Q1[1], I1[1], I2[1], Q2[1];
    static double jI[1], jQ[1], Re[1], Im[1], period[1], Phase[1];
    //----   
    if (ArraySize(smooth)<BARS)
     {
      ArraySetAsSeries(smooth,    false);
      ArraySetAsSeries(detrender, false);
      ArraySetAsSeries(period,    false);
      ArraySetAsSeries(Phase,     false);
      ArraySetAsSeries(Q1, false);
      ArraySetAsSeries(I1, false);
      ArraySetAsSeries(I2, false);
      ArraySetAsSeries(Q2, false);
      ArraySetAsSeries(jI, false);
      ArraySetAsSeries(jQ, false);
      ArraySetAsSeries(Re, false);
      ArraySetAsSeries(Im, false);
      //----  
      ArrayResize(smooth,    BARS);
      ArrayResize(detrender, BARS);
      ArrayResize(period,    BARS);
      ArrayResize(Phase,     BARS);
      ArrayResize(Q1, BARS);
      ArrayResize(I1, BARS);
      ArrayResize(I2, BARS);
      ArrayResize(Q2, BARS);
      ArrayResize(jI, BARS);
      ArrayResize(jQ, BARS);
      ArrayResize(Re, BARS);
      ArrayResize(Im, BARS);
      //----
      ArraySetAsSeries(smooth,    true);
      ArraySetAsSeries(detrender, true);
      ArraySetAsSeries(period,    true);
      ArraySetAsSeries(Phase,     true);
      ArraySetAsSeries(Q1, true);
      ArraySetAsSeries(I1, true);
      ArraySetAsSeries(I2, true);
      ArraySetAsSeries(Q2, true);
      ArraySetAsSeries(jI, true);
      ArraySetAsSeries(jQ, true);
      ArraySetAsSeries(Re, true);
      ArraySetAsSeries(Im, true);
     }  
    //----+        
    int MaxBar, limit, bar, counted_bars=IndicatorCounted();
    //----    
    if (counted_bars<0)return(-1);
    //----      
    if (counted_bars>0) counted_bars--;
    //----+     
    double DeltaPhase, alpha; 
    //----     , 
             //         
    MaxBar=Bars-1-7;
    //----     , 
             //         
    limit = Bars - 1 - counted_bars;
    //----  
    if(limit>=MaxBar)
     {
       for(bar = Bars - 1; bar > MaxBar; bar--) 
         {
           MAMA[bar] = 0.0;
           FAMA[bar] = 0.0;
           smooth[bar] = 0.0;
           detrender[bar] = 0.0;
           period[bar] = 0.0;
           Phase[bar] = 0.0;
           Q1[bar] = 0.0;
           I1[bar] = 0.0;
           I2[bar] = 0.0;
           Q2[bar] = 0.0;
           jI[bar] = 0.0;
           jQ[bar] = 0.0;
           Re[bar] = 0.0;
           Im[bar] = 0.0;
           limit=MaxBar;
         }
     }
    //----
    for (bar=limit;bar>=0;bar--)
      {
	     smooth[bar] = (4*PriceSeries(IPC, bar+0) + 3*PriceSeries(IPC, bar+1) 
	                         + 2*PriceSeries(IPC, bar+2) + PriceSeries(IPC, bar+3)/010);
        //---+
        detrender[bar] = (0.0962*smooth[bar+0] + 0.5769*smooth[bar+2] 
            - 0.5769*smooth[bar+4] - 0.0962*smooth[bar+6])* (0.075*period[bar+1] + 0.54);

        //---+ Compute InPhase and Quadrature components
        Q1[bar] = (0.0962*detrender[bar+0] + 0.5769*detrender[bar+2] - 0.5769*detrender[bar+4] 
                                   - 0.0962*detrender[bar+6])*(0.075*period[bar+1] + 0.54);
	     I1[bar] = detrender[bar+3];
        //---+ Advance the phase of I1 and Q1 by 90 degrees
	     jI[bar] = (0.0962*I1[bar+0] + 0.5769*I1[bar+2] - 0.5769*I1[bar+4] 
	                                        - 0.0962*I1[bar+6])*(0.075*I1[bar+1] + 0.54);
	     jQ[bar] = (0.0962*Q1[bar+0] + 0.5769*Q1[bar+2] - 0.5769*Q1[bar+4] 
	                                        - 0.0962*Q1[bar+6])*(0.075*Q1[bar+1] + 0.54);
        //---+ Phasor addition for 3 bar averaging
        I2[bar] = I1[bar] - jQ[bar];
	     Q2[bar] = Q1[bar] - jI[bar];
	     //---+ Smooth the I and Q components before applying the discriminator
	     I2[bar] = 0.2*I2[bar] + 0.8*I2[bar+1];
        Q2[bar] = 0.2*Q2[bar] + 0.8*Q2[bar+1];
        //---+ Homodyne Discriminator
    	  Re[bar] = I2[bar]*I2[bar+1] + Q2[bar]*Q2[bar+1];
    	  Im[bar] = I2[bar]*Q2[bar+1] - Q2[bar]*I2[bar+1];
        //---+ 
        Re[bar] = 0.2*Re[bar] + 0.8*Re[bar+1];
        Im[bar] = 0.2*Im[bar] + 0.8*Im[bar+1];
        //---+
        if (Im[bar]!=0||Re[bar]!=0)period[bar] = 6.285714/MathArctan(Im[bar]/Re[bar]);
        //---+
        if (period[bar] > 1.50*period[bar+1]) period[bar] = 1.50*period[bar+1];
        if (period[bar] < 0.67*period[bar+1]) period[bar] = 0.67*period[bar+1];
        if (period[bar] < 6.00*period[bar+1]) period[bar] = 6.00;      
        if (period[bar] > 50.0*period[bar+1]) period[bar] = 50.0;
        //---+
        period[bar] = 0.2*period[bar] + 0.8*period[bar+1];
        //---+
        if (I1[bar]!=0)Phase[bar] = 57.27272987*MathArctan(Q1[bar] / I1[bar]);
        //---+
        DeltaPhase = Phase[bar+1] - Phase[bar];
        if (DeltaPhase < 1)DeltaPhase = 1.0;
        //---+
        alpha = FastLimit / DeltaPhase;
        if (alpha < SlowLimit)alpha = SlowLimit;
        //---+
        MAMA[bar] = alpha*PriceSeries(IPC, bar) + (1.0 - alpha)*MAMA[bar+1];
        FAMA[bar] = 0.5*alpha*MAMA[bar] + (1.0 - 0.5*alpha)*FAMA[bar+1];    
      }
    return(0);
  }
//+--------------------------------------------------------+

